package expression

object PrettyPrinter {
  def stringOf(e: Expression): String = {
    e match {
      case Constant(i) => i.toString
      case Variable(v) => v
      case Sum(e1, e2) => "(" + stringOf(e1) + " + " + stringOf(e2) + ")"
      case Sub(e1, e2) => "(" + stringOf(e1) + " - " + stringOf(e2) + ")"
    }
  }
}
