package smallCheck
import org.junit.Assert._
import org.junit.Test

import expression._

class TestSmallCheck {
  @Test
  def testInt(): Unit = {
    assertEquals(
      Set(-2, -1, 0, 1, 2),
      SmallCheck.genInt(2)
    )
  }

  @Test
  def testConstant(): Unit = {
    assertEquals(
      Set(Constant(-2), Constant(-1), Constant(0), Constant(1), Constant(2)),
      SmallCheck.genConstant(2)
    )
  }

  @Test
  def testString(): Unit = {
    assertEquals(
      3,
      SmallCheck.genString(3).size
    )
  }

  @Test
  def testExp1(): Unit = {
    assertEquals(
      4,
      SmallCheck.genExpression(1).size
    )
  }

  @Test
  def testExp2(): Unit = {
    assertEquals(
      105,
      SmallCheck.genExpression(2).size
    )
  }

  @Test
  def testExp3(): Unit = {
    assertEquals(
      88210,
      SmallCheck.genExpression(3).size
    )
  }

  @Test
  def testMaps0(): Unit = {
    assertEquals(Set(Map()), SmallCheck.genMaps(0))
  }

  @Test
  def testMaps1(): Unit = {
    assertEquals(
      4,
      SmallCheck.genMaps(1).size
    )
  }

  @Test
  def testMaps2(): Unit = {
    assertEquals(36, SmallCheck.genMaps(2).size)
  }

  @Test
  def testMaps3(): Unit = {
    assertEquals(
      512,
      SmallCheck.genMaps(3).size
    )
  }

}
